interface AnyObject{
    [prop: string]: any;
}

export default class Data {
    static _task: Array<()=>boolean>;
    static _getStore: (name: string) => Data|null;
    static staticCheck: (value: boolean) => void;

    name: string;
    globaleStore: ReduxStore;
    _hookListeners: {
        [actionType: string]: Array<{
            from: string;
            getDispatch: ()=>(action: Action, snapshot: AnyObject)=>any;
        }>
    }
    _eventCache: {
        [eventName: string]: (...args: any[])=>Action;
    }
    defaultData: AnyObject;
    _reducerArr: Array<{
        [actionType: string]: Reducer<AnyObject, Action>
    }>
    _reducer: Reducer<AnyObject, Action>;

    constructor(name: string, defaulData?: AnyObject){};
    getDispatch(eventName: string): DispatchFunc;
    listen(eventName, config): Data;
    asifReducer(): ReducerLike<AnyObject, Action>;
    addReducer(actionType: string, reducerFunc: Reducer<AnyObject, Action>): Data;
    listenOther(actionType: string, cb: (action: Action, snapshot: AnyObject)=>any): Data;
    getActionType(eventName: string): string;
    init(store: ReduxStore): void;
}
interface Reducer<T, A>{
    (state: T, action?: A): T;
}

interface ReduxStore{
    dispatch: (action: Action)=>any;
    getState: ()=>AnyObject;
}
interface DispatchFunc{
    (eventName?: string, ...rest:any[]):any
}
interface ReducerLike<T, A>{
    (state: T, action?: A): T;
    dispatch: DispatchFunc;
    reset: ()=>any;
    _data: Data;
}
interface Action {
    type: string;
    data?: AnyObject;
    [otherProps: string]: any;
}